﻿using HeuristicLab.Core;
using HeuristicLab.Encodings.BinaryVectorEncoding;

namespace HeuristicLab.Algorithms.ScatterSearch.Knapsack {
  public sealed class DiversityCalculator {
    public static int CalculateDiversity(IItem p, IItem r) {
      BinaryVector pSol = p as BinaryVector;
      BinaryVector rSol = r as BinaryVector;
      int diversity = 0;
      if (pSol != null && rSol != null)
        for (int i = 0; i < pSol.Length; i++)
          if (pSol[i] != rSol[i]) diversity++;
      return diversity;
    }
  }
}
